package com.gtf.controller;

import com.gtf.abstractHanler.GateawayHandler;
import com.gtf.dyg.CurrentLimitHanler;
import com.gtf.factory.FactoryHanlder;
import com.gtf.factory.temlateFactory;
import com.gtf.payContextStrategy.PayContextStrategy;
import com.gtf.template.AbstractPayCallTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class PayController {
    @Autowired
    private PayContextStrategy payloadContextStr;
    @Autowired
    private FactoryHanlder factory;


    @GetMapping("/topay")
    public String topayAction(String paycode) throws ClassNotFoundException, InstantiationException, IllegalAccessException {
        return payloadContextStr.toPayHtml(paycode);
    }
    @GetMapping("/hanlder")
    public void hanlder() throws ClassNotFoundException, InstantiationException, IllegalAccessException {
        GateawayHandler currentLimitHanlder = factory.getDbFirstGatewayHandler();
        currentLimitHanlder.service();
    }
    @GetMapping("/template")
    public String template(String templateId) throws ClassNotFoundException, InstantiationException, IllegalAccessException {
        AbstractPayCallTemplate payCallTemplate = temlateFactory.getPayCallTemplate(templateId);
      //使用模版方法执行 共同的骨架
     return    payCallTemplate.asyncCall();
    }
}
